function bode_exp(w_freq, W_exp, fmt = ';;', holdon = 0) 
	if (ismatrix(W_exp)) 
		L_exp = 20*log10(abs(W_exp));
		phi_exp = 180/pi*arg(W_exp);
		phi_exp_corr = phi_exp;
		phi_corr = 0;
		for k = 2:length(phi_exp) 
			dphi = phi_exp(k) - phi_exp(k-1);
			if (dphi > 180)
				phi_corr -= 360;
			elseif (dphi < -180)
				phi_corr += 360;
			end
			phi_exp_corr(k) += phi_corr;
		end
	else
		[A_exp, phi_exp_corr] = bode(W_exp, w_freq);
		L_exp = 20*log10(A_exp);
	end

	subplot(2, 1, 1);
	if (holdon)
		hold on
	else
		hold off
	end
	semilogx(w_freq, L_exp, fmt)
	xlabel('Frequency, rad/sec');
	ylabel('Gain, db');
	grid on	

	subplot(2, 1, 2);
	if (holdon)
		hold on
	else
		hold off
	end
	semilogx(w_freq, phi_exp_corr, fmt);
	xlabel('Frequency, rad/sec');
	ylabel('Phase, deg');
	grid on	
	%subplot(1, 1, 1)
end

