% частотный анализ: проводим ряд экспериментов
% вход --- гармонические сигналы

if (is_simalution)
	U0 = 2;  % амплитуда входного сигнала
	wfreq = 2*pi*logspace(-1,1.5,8); % частоты
	% проводим эксперименты
	N = 1024*8;
	tgen
	for k = 1:length(wfreq)
		u = U0*sin(wfreq(k) * t);
		simulate
		U{k} = u;
		Y{k} = y;
	end
end

% сторим оценку ПФ
Gz_est = zeros(size(wfreq));
for k = 1:length(wfreq)
	w = wfreq(k);
	u = U{k};
	y = Y{k};
	% для вычисления cos преобразования входной sin надо сдвинуть на pi/2
	k_w = round((pi/2)/w/Ts);
	% корреляция --- оценка Is
	Kzu0 = sum(y .* u) / N;
	% корреляция --- оценка Iс
	Kzuw = sum(y(1:N-k_w) .* u(k_w+1:N)) / (N-k_w);
	Gz_est(k) = (2 / U0^2)*(Kzu0 + j*Kzuw);
end

% оцениваем передаточную функцию
ind = 1:length(wfreq)-2;
[Gb_est, Ga_est] = invfreqs(Gz_est(ind), wfreq(ind), 0, 2);
Gs_mod = tf(Gb_est, Ga_est);

bode_exp(wfreq, Gz_est, 'o-;Gz_est;r', 0);
if (is_simalution && display_real_plot)
	bode_exp(logspace(-1,3,100), Gz, ';Gz;b', 1);
end
bode_exp(logspace(-1,3,100), Gs_mod, ';Gz_{mod};g', 1);
