% гармонический анализ: один периодический сигнал
% вход --- переодический  шум

if (is_simalution)
	u = randn([4096 1]);
	N0 = size(u, 1); % период входного сигнала
	u = repmat(u, [5 1]); % указываем число периодов

	simulate
end

% вычисляем периодограммы
Yn = 1/sqrt(N)*fft(y);
Un = 1/sqrt(N)*fft(u);

% выделяем значимые частоты
kfreq = linspace(0,N0-1,N0)*(N/N0) + 1;
wfreq = ws * ((kfreq-1)/N)';
Yn = Yn(kfreq);
Un = Un(kfreq);

% строим эмпирическую оценку передаточной функции
Gz_est = Yn ./ Un;

% подбираем подходящую непрерывную модель
ind = 1:15; % число отчетов
[Gb_est, Ga_est] = invfreqs(Gz_est(ind), wfreq(ind), 0, 2);
Gs_mod = tf(Gb_est, Ga_est);

% сторим графики
bode_exp(wfreq(2:end), Gz_est(2:end), '-;Gz_est;r', 0);
if (is_simalution && display_real_plot)
	bode_exp(logspace(-1,3,100), Gs, ';Gz;b', 1);
end
bode_exp(logspace(-1,3,100), Gs_mod, ';Gz_mod;g', 1);
