% метод инструментальных переменных для ARX модели
% вход: сигнал с постоянным возбуждением порядка не ниже порядка модели

if (is_simalution)
	u = 100*randn([10000 1]);
	%u = load('input1.txt');
	simulate
end

% задаем порядок модели
nb = 2;
na = 2;

% применяем МНК для ARX модели
Z = iddata(y, u, Ts);
Wz_arx = arx(Z, 'NA', na, 'NB', nb);
Gz_arx = Wz_arx(1,1);

% строим вектор инструментальных переменных и регрессоров
x = lsim(Gz_arx, u);
iv = zeros([size(u,1) na+nb]);
phi = zeros([size(u,1) na+nb]);
for k = 1:na
	iv(1+k:end, k) = -x(1:end-k);
	phi(1+k:end, k) = -y(1:end-k);
end
for k = 1:nb
	iv(1+k:end, na+k) = u(1:end-k);
	phi(1+k:end, na+k) = u(1:end-k);
end

% находим параметры модели --- скорее всего этот метод плох или надо добавлять фильтр L в китерий
RN = 1/N * iv'*phi;
FN = 1/N * iv'*y;
teta = RN \ FN;
Gz_iv = filt([0; teta(na+1:end)], [1; teta(1:na)], Ts);

% строим графики
figure(1)
bode_exp(wfreq, Gz_iv, ';Gz_{iv};r', 0);
if (is_simalution && display_real_plot)
	%bode_exp(wfreq, Gz, ';Gz;b', 1);
	bode_exp(wfreq, Gs, ';Gs;g', 1);
end
