% спектральный анализ: вход --- шум

if (is_simalution)
	u = randn([10000 1]);
	simulate
end

% длина преобразования Фурье: определяет частоты
seg = 1024;
% коэффициент ширины окна: чем он больше, тем окно уже
gwin = 3;

% оценка передаточной функции
[Gz_est, vfreq] = tfestimate(u, y, hamming(round(gwin*seg)), 0.5, seg, vs);
wfreq = 2*pi*vfreq;

% подбираем подходящую непрерывную модель
% если есть оценка спектра возмущения, то
% можно добавить веса в виде соотношения сигнал/шум 
ind = 1:20;
[Gb_est, Ga_est] = invfreqs(Gz_est(ind), wfreq(ind), 0, 2);
Gs_mod = tf(Gb_est, Ga_est);

% рисуем графики
bode_exp(wfreq(2:end), Gz_est(2:end), '-;Gz_{est};r', 0);
if (is_simalution && display_real_plot)
	bode_exp(logspace(-1,3,100), Gs, ';Gz;b', 1);
end
bode_exp(logspace(-1,3,100), Gs_mod, ';Gz_{mod};g', 1);


