%seg = 1024;

% параметр окна
gwin = 3; 

% оценки спекра входа, выхода и взаимный спектр
pwelch(''); % порядок аргументов как у octave
[Fy, vfreq] = pwelch(y, hamming(round(gwin*seg)), 0.5, seg, vs);
Fu = pwelch(u, hamming(round(gwin*seg)), 0.5, seg, vs);
Fyu = pwelch(u, y, hamming(round(gwin*seg)), 0.5, seg, vs, 'cross');

% переходим к круговым частотам
wfreq = 2*pi*vfreq;

% вычисляем коэффициент корреляции для разных частот
kappa1 = abs(Fyu) ./ sqrt(Fy.*Fu);

% сглаживаем его (усредняем по gmean*seg значениям)
kappa2 = vertcat(flipud(kappa1),kappa1);
slide = hamming(round(0.05*seg));
slide = slide / sum(slide);
kappa2 = conv(kappa2,slide,'same');
kappa2 = kappa2(size(kappa2,1)/2 + 1 : end);
kappa2 = min(kappa2, 1.0); % коэффициент не может быть больше единицы

% вычисляем оценку спектра шума,
% домножаем на частоту выборки, т.к. pwelch делит спектр на нее
Fv_est = Fy .* (1 - kappa1 .^ 2) * vs;

subplot(1,1,1);
subplot(2,1,1);
hold off
semilogx(wfreq,kappa1,';kappa;r')
hold on
semilogx(wfreq,kappa2,';kappa smoothed;g')
grid on
subplot(2,1,2);
hold off
semilogx(wfreq,log(Fv_est),';Fv_{est};r')
if (is_simalution && display_real_plot)
	% вычисляем спектр реального сигнала
	Fv = e_cov * abs(freqz(Hb, Ha, length(wfreq), ws)) .^ 2;
	hold on
	semilogx(wfreq,log(Fv),';Fv;b')
end
grid on
hold off
